class Cola{
	private int[] v; //arreglo de enteros
	private int primero, ultimo, numElem;
	private int max_size;

	//invariante
	private boolean invariante(){ return numElem <= max_size && v !=null;}
	
	//constructor
	public Cola(int size){
		assert size > 0 : "tamao invalido";
		v=new int[size];
		primero=0;
		ultimo=size-1;
		numElem=0;
		max_size=size;
	}

	//encola un elemento en la cola
	public void encolar(int x){
		assert numElem < max_size : "Cola esta llena";
    	ultimo=(ultimo+1)%max_size;
    	v[ultimo]=x;
    	numElem++;
    	assert invariante();
	}

	//saca un elemento de la cola
	public int sacar(){
		assert ( !estaVacia() ) : "No hay elementos en la Cola";
		int x=v[primero];
		primero=(primero+1)%max_size;
		numElem--;
		assert invariante(); 
		return x;
	}

	//verifica si la cola esta vacia
	public boolean estaVacia(){
		return numElem==0;
	}
}