class Cola<T>{
	private T[] v; //arreglo GENERICO
	private int primero, ultimo, numElem;
	private int max_size;

	//invariante
	private boolean invariante(){ return numElem <= max_size && v !=null;}
	
	//constructor
	public Cola(int size){
		assert size > 0 : "tamao invalido";
		//v=new T[size];
		v = (T[]) new Object[size];
		primero=0;
		ultimo=size-1;
		numElem=0;
		max_size=size;
	}

	//encola un elemento del tipo T en la cola
	public void encolar(T x){
		assert numElem < max_size : "Cola esta llena";
    	ultimo=(ultimo+1)%max_size;
    	v[ultimo]=x;
    	numElem++;
    	assert invariante();
	}

	//saca un elemento de la cola
	public T sacar(){
		assert ( !estaVacia() ) : "No hay elementos en la Cola";
		T x=v[primero];
		primero=(primero+1)%max_size;
		numElem--;
		assert invariante(); 
		return x;
	}

	public boolean estaVacia(){
		return numElem==0;
	}
}